import sys

class vector:

  def __init__(self):
     SEP.util.err ( "Calling umimplented method")

  def clone(self,space_only=None):
    SEP.util.err( "Calling unimplemtned method   ")

  def clone_space(self):
    return self.clone(space_only=1)

  def zero(self):
     """Zero a vector"""
     SEP.util.err( "Calling umimplented method")

  def random(self):
     """Put random  numbers into vector"""
     SEP.util.err( "Calling umimplented method")

  def scale(self,scale):
     """out=out*scale"""
     SEP.util.err ( "Calling umimplented method")

  def add(self,add):
     """out=out+add"""
     SEP.util.err ( "Calling umimplented method")

  def scale_add(self,scale,add):
     """out=out+scale*add"""
     self.scale_addscale(0.,add,scale)

  def scale_addscale(self,scale1,add,scale2):
     """out=out*scale1+scale2*add"""
     SEP.util.err ( "Calling umimplented method")

  def multiply(self,othervec):
     """Multiply a vector with another vector"""
     SEP.util.err("Calling umimplented method")

  def dot(self,othervec):
     """Dot product vector with  another vectory """
     SEP.util.err( "Calling umimplented method")

  def load(self,name):
    """Load a vector"""
    SEP.util.err ("Load vector not defined")

  def size(self):
     """Return the size for simple logic checking """
     SEP.util.err( "Calling umimplented method")

  def clean(self):
     """Clean a vector """
     SEP.util.err( "Calling umimplented method")

class super_vector(vector):

  def __init__(self,name,vec_list):
     self.name=name
     self.vecs=vec_list

  def load(self):
     """ Load a s super vector"""
     for vec in self.vecs: vec.load()

  def clone_space(self,name=None):
    return self.clone(name,space_only=1)

  def clone(self,name=None,space_only=None):
     """ Clone a s super vector"""
     vec_list=[]
     i=0
     if not name: name=self.name+"_clone"
     for vec in self.vecs:
       vec_list.append(vec.clone(name=name+str(i),space_only=space_only))
       i+=1
     junk=super_vector(name,vec_list)
     return junk

  def zero(self):
     """Zero a vector"""
     for vect in self.vecs: vect.zero()

  def random(self):
     """Put random  numbers into vector"""
     for vect in self.vecs: vect.random()

  def scale(self,scale):
     """out=out*scale"""
     for vect in self.vecs: vect.scale(scale)

  def add(self,add):
     """out=out+add"""
     if len(self.vecs) != len(add.vecs):
       SEP.util.err("incompatible vectors to scale_addscale")
     for i in range(len(self.vecs)):
       self.vecs[i].add(add.vecs[i])


  def scale_addscale(self,scale1,add,scale2):
     """out=out*scale1+scale2*add"""
     if len(self.vecs) != len(add.vecs):
       SEP.util.err("incompatible vectors to scale_addscale")
     for i in range(len(self.vecs)):
       self.vecs[i].scale_addscale(scale1,add.vecs[i],scale2)

  def multiply(self,othervec):
     """Multiply a vector with another vector"""
     if len(self.vecs) != len(othervec.vecs):
       SEP.util.err("incompatible vectors to multiply")
     for i in range(len(self.vecs)):
       self.vecs[i].multuply(othervec.vecs[i])

  def dot(self,othervec):
     """Dot product vector with  another vectory """
     d_list=[]
     if len(othervec.vecs) != len(self.vecs):
       SEP.util.err("Attempt to dot incompatible vectors %s and %s"%(self.name,othervec.name))
     for i in range(len(self.vecs)):
       d_list.append(self.vecs[i].dot(othervec.vecs[i]))
       dtot=0
       for d in d_list: 
         dtot+=d
     return dtot

  def size(self):
    n=0
    for vect in self.vecs: n=int(n)+int(vect.size())
    return n

  def clean(self):
    for vect in self.vecs:vect.clean()
