program geop_prec
use sep
use geop_prec_mute_mod
logical :: mute,mute_beg
integer :: nreg(5)
integer :: ierr
real    :: opx,dpx
logical :: prec,for,adj,add
character(len=128) :: model,data


call sep_init(SOURCE)
call set_no_putch()
call auxinout("model")
call auxinout("data")
call from_param("mute",mute,.false.)
call from_aux("model","n1",nreg(1))
call from_aux("model","n2",nreg(2))
call from_aux("model","n3",nreg(3))
call from_aux("model","n4",nreg(4))
call from_aux("model","n5",nreg(5))
call from_aux("model","o3",opx)
call from_aux("model","d3",dpx)
call from_param("mute_beg",mute_beg,.false.)
                                                                                

call from_param("prec",prec,.false.)
call from_param("for",for,.false.)
call from_param("add",add,.false.)
call from_param("adj",adj,.false.)
call geop_prec_init(nreg,opx,dpx,mute,mute_beg)

model="model"
data="data"
if (prec) then
  if (for) then
    ierr= geop_for_prec(adj,add,model,data)
  else
    ierr= geop_bak_prec(adj,add,model,data)
  end if
else
  if (for) then
    ierr= geop_for_reg(adj,add,model,data)
  else
    ierr= geop_bak_reg(adj,add,model,data)
  end if
end if




end program
