program wt_func
use sep3d_struct_mod
use sep
complex,allocatable:: mod(:),dat(:)
real,allocatable:: wt(:)
integer :: i,i5,n
type(sep3d) :: space
logical :: adj,add

call sep_init()
call from_param("add",add,.false.)
call from_param("adj",adj,.false.)
if(.not. adj) then
  call init_sep3d("model",space,"INPUT")
  call auxinout("data")
else
  call init_sep3d("data",space,"INPUT")
  call auxinout("model")
end if
n=product(space%n(1:4))
allocate(mod(n),dat(n),wt(n))
do i5=1,space%n(5)
  call sreed("wt",wt,size(wt)*4)
  write(0,*) "CHECK THIS",sum(wt)
  if(adj) then
    call sreed("data" ,dat,size(dat)*8)
    if(.not. add) then
      mod=0
    else
      call sreed("model",mod,size(mod)*8)
      call sseek("model",-n*8,1)
    end if
    mod=mod+dat*wt
    call srite("model",mod,size(mod)*8)
  else
    call sreed("model" ,mod,size(mod)*8)
    if(.not. add) then
      dat=0
    else
      call sreed("data" ,dat,size(dat)*8)
      call sseek("data",-n*8,1)
    end if
    dat=dat+mod*wt
    call srite("data",dat,size(dat)*8)
  end if
end do

  
  


end program
