import commands
import SEP.util
import os
import string
import SEP.status

class par_status(SEP.status.sep_status):

   def __init__(self,file,par_list,logfile_func=None):
      """Initialize a parallel status of a job"""
      SEP.status.sep_status.__init__(self,file,job_list=par_list,njob_extra=3)
      self.logfile=logfile_func


   def print_status_info(self,job):
        stats=self.status[job].split(":")
        stat=stats[0]
        if stat == "todo": print "%s: Not done"%key
        elif stat == "sent": print "%s: sent but not registered  %s %s"%(key,stats[1],stats[2])
        elif stat == "finished":  print "%s: finished succesfully %s %s"%(key,stats[1],stats[2])
        elif stat == "running": 
          if doit==0: print "%s: running %s %s "%(key,stats[1],stats[2])
          else: 
            file=self.logfile(val)
            if os.path.isfile(file):
                out=commands.getoutput("tail -2 "+file)
                print "%s: running %s \n%s",(key,extra,out)
            else: SEP.util.err("Logfile %s doesn't exist"%file)


   def get_other_dict(self,key_list):
     """Get the other status given a key list"""
     return self.get_stat_elem(1,key_list)

   def get_failures(self,key):
     """Get the the number of failures of a given job"""
     SEP.util.lock_desc(self.my_lock)
     self.readit()
     as=self.status[key].split(":")
     SEP.util.unlock_desc(self.my_lock)
     if len(as) < 4 : return 0
     if as[3] == "none": b=0
     else: b=int(as[3])
     return b

   def set_failure(self,key,val):
     """Set the number of failures for a given job"""
     self.set_key_status_elem(key,3,val)

   def add_failure(self,key):
     """Record a failure for a given job"""
     self.set_failure(key,self.get_failures(key)+1)

   def status_dict(self,keys):
     return self.get_stat_elem(0,keys)
     """Return the status of a series of keys"""
