program geologic
use sep
use geol_prec_mod
integer :: nreg(5)
integer :: ierr
real    :: opx,dpx
logical :: prec,for,adj,add
character(len=128) :: model,data


call sep_init(SOURCE)
call set_no_putch()
call auxinout("model")
call auxinout("data")
call from_aux("model","n1",nreg(1))
call from_aux("model","n2",nreg(2))
call from_aux("model","n3",nreg(3))
call from_aux("model","n4",nreg(4))
call from_aux("model","n5",nreg(5))

call from_param("prec",prec,.false.)
call from_param("add",add,.false.)
call from_param("adj",adj,.false.)
call geol_prec_init(nreg)

model="model"
data="data"
if (prec) then
    ierr= geol_prec(adj,add,model,data)
else
    ierr= geol_reg(adj,add,model,data)
end if




end program
